## readsb-3.9.0.tar.gz

=== Makefile ===
PROGNAME=readsb
READSB_VERSION='v3.9.0'

RTLSDR ?= no
BLADERF ?= no
PLUTOSDR ?= no
AGGRESSIVE ?= no
HAVE_BIASTEE ?= no

CPPFLAGS += -DMODES_READSB_VERSION=\"$(READSB_VERSION)\" -DMODES_READSB_VARIANT=\"Mictronics\" -D_GNU_SOURCE

DIALECT = -std=c11
CFLAGS += $(DIALECT) -O2 -g -W -D_DEFAULT_SOURCE -Wall -Werror -fno-common
LIBS = -pthread -lpthread -lm -lrt

ifeq ($(AGGRESSIVE), yes)
  CPPFLAGS += -DALLOW_AGGRESSIVE
endif

ifeq ($(RTLSDR), yes)
  SDR_OBJ += sdr_rtlsdr.o
  CPPFLAGS += -DENABLE_RTLSDR

  ifeq ($(HAVE_BIASTEE), yes)
    CPPFLAGS += -DENABLE_RTLSDR_BIASTEE
  endif

  ifdef RTLSDR_PREFIX
    CPPFLAGS += -I$(RTLSDR_PREFIX)/include
    LDFLAGS += -L$(RTLSDR_PREFIX)/lib
  else
    CFLAGS += $(shell pkg-config --cflags librtlsdr)
    LDFLAGS += $(shell pkg-config --libs-only-L librtlsdr)
  endif

  ifeq ($(STATIC), yes)
    LIBS_SDR += -Wl,-Bstatic -lrtlsdr -Wl,-Bdynamic -lusb-1.0
  else
    LIBS_SDR += -lrtlsdr -lusb-1.0
  endif
endif

ifeq ($(BLADERF), yes)
  SDR_OBJ += sdr_bladerf.o sdr_ubladerf.o
  CPPFLAGS += -DENABLE_BLADERF
  CFLAGS += $(shell pkg-config --cflags libbladeRF)
  LIBS_SDR += $(shell pkg-config --libs libbladeRF)
endif

ifeq ($(PLUTOSDR), yes)
    SDR_OBJ += sdr_plutosdr.o
    CPPFLAGS += -DENABLE_PLUTOSDR
    CFLAGS += $(shell pkg-config --cflags libiio libad9361)
    LIBS_SDR += $(shell pkg-config --libs libiio libad9361)
endif

all: readsb viewadsb

%.o: %.c *.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $< -o $@

readsb: readsb.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o demod_2400.o stats.o cpr.o icao_filter.o track.o util.o convert.o sdr_ifile.o sdr_beast.o sdr.o ais_charset.o $(SDR_OBJ) $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) $(LIBS_SDR) -lncurses

viewadsb: viewadsb.o anet.o interactive.o mode_ac.o mode_s.o comm_b.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o ais_charset.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LDFLAGS) $(LIBS) -lncurses

clean:
	rm -f *.o compat/clock_gettime/*.o compat/clock_nanosleep/*.o readsb viewadsb cprtests crctests convert_benchmark

test: cprtests
	./cprtests

cprtests: cpr.o cprtests.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm

crctests: crc.c crc.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -DCRCDEBUG -o $@ $<

benchmarks: convert_benchmark
	./convert_benchmark

oneoff/convert_benchmark: oneoff/convert_benchmark.o convert.o util.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm

oneoff/decode_comm_b: oneoff/decode_comm_b.o comm_b.o ais_charset.o
	$(CC) $(CPPFLAGS) $(CFLAGS) -g -o $@ $^ -lm

=== debian/changelog ===
readsb (3.9.0) stable; urgency=medium

  * Last and final release of this readsb version.
  * Support GNS HULC antenna.
  * Interrupt driven serial device handling removed.
  * Clean up linkage of struct Modes. (via dump1090-fa)
  * Build with -fno-common to match GCC 10 behaviour on older compiler versions. (via dump1090-fa)
  * Use precise location on local map.
  * Contribution wiedehopf:
    * Improve altitude filter.
    * Show zero timestamps using viewadsb.

 -- Michael Wolf <michael@mictronics.de>  Sat, 01 Aug 2020 10:20:10 +0200

readsb (3.8.3) stable; urgency=medium

  * Add marker types for ground vehicles and towers.
  * Fix bug in handling bladeRF command line options.
  * Contribution wiedehopf:
    * Improvement of SBS decoding
    * Connection timed out: remove misleading explanation
    * keepalive: set and check for error in net_io.c instead of blindly doing it in anet.c
    * Add custom keepalive settings that will time out a broken connection after 30 seconds.
    * Move from global client list to one client list per service.
    * Fix anet open_fd limiting to include all used sockets.
    * Avoid excessive iteration over Modes.clients.
    * Move network cleanup to net_io.c and use closeClient.
    * Perform some network task less often.
    * Improved accept handling.

 -- Michael Wolf <michael@mictronics.de>  Sun, 03 May 2020 10:30:05 +0200

readsb (3.8.2) stable; urgency=medium

  * Webapp: History loading and trace collection moved to background worker.
  * Fix hidding SkyVector layers when no API key is present.
  * Fix latest stats, was always zero, is now momentary statistic.
  * Fix bug in overlay layer generation when language is not English.
  * Add DC-10 aircraft marker.
  * Disable source maps for third-party scripts.
  * Fix sporatic buffer overflow in JSON stats generation.
  * Zero initalize new network clients.
  * Prevent segmentation fault on invalid protocol name.

 -- Michael Wolf <michael@mictronics.de>  Sun, 01 Mar 2020 10:02:17 +0100

readsb (3.8.1) stable; urgency=medium

  * Load default web application settings from JSON file.
  * Introduce a dark theme.
  * Via dump1090:
    * Treat ADS-R as a separate source type.
    * Track ADS-B version separately for direct ADS-B, TIS-B, ADS-R.
    * Compute ADS-B v0 NACp/SIL from position message type
    * Correct block duration with PlutoSDR, fix issue #17.
  * Contribution by wiedehopf and tanerH:
    * Increase network buffers.
    * Removed redundant history code.
    * Filtering for implausible altitudes.
    * Use multible linked lists for aircraft list.
    * Add max distance to stats.json.
    * Network improvements and fixes.
    * Add VRS JSON network writer.
    * Fixed push client.
    * More statistics for beast network input.
    * Improved VRS JSON generation.
    * Implementation of non-blocking TCP connection.
    * Improved handling of multible address records.
    * Removed legacy push server commands. Replaced by --net-connector.
    * BeastReduce output - Reduced message rate for non-physical aircraft data.
    * Aynchronous name resolution based on pthread.
    * Fix network connection in viewadsb.

 -- Michael Wolf <michael@mictronics.de>  Mon, 06 Jan 2020 09:43:24 +0200

readsb (3.8.0) stable; urgency=medium

  * Multi language support in web application.
  * Uses I18next for internationalization.
  * Web application reworked and ported to Typescript.
  * Moved to Leaflet map library.
  * Replace obsolete usleep in POSIX 2008 with nanosleep.
  * Improvements to position filtering and relative decoding.
  * Position decoding bugfixes.
  * When generating aircraft.json, leave space for the final line.
  * Forward alert and spi bits to web application.
  * Added support for GNS5894 receiver hardware.

 -- Michael Wolf <michael@mictronics.de>  Tue, 03 Dec 2019 19:11:17 +0200

readsb (3.7.3) stable; urgency=medium

  * First stable release under new package name readsb.
  * Improve package installation and removal.
  * Fork detached from dump1090-fa into standalone project and renamed to readsb.
  * Accept profiles to build package with indivitual or no receiver library dependencies.

 -- Michael Wolf <michael@mictronics.de>  Tue, 03 Sep 2019 18:52:56 +0200

readsb (3.7.2) stable; urgency=medium

  * Added configurable re-connection delay for push server support.
  * Add bladeRF v2.0 Micro support (credits @kazazes)

 -- Michael Wolf <michael@mictronics.de>  Fri, 26 Jul 2019 18:47:32 +0200

readsb (3.7.1) stable; urgency=medium

  * Update aircraft database.
  * Fix web app to make links and button in selected plane dialog accessible.
  * Removed obsolete code and styles in web app.
  * jQuery touchpunch updated to bugfixed fork.
  * Extended aircraft species filter and added engine type filter.
  * Add OpenFlightMap layer.
  * Update to OpenLayers v5.3.3 and fix code compatibility.
  * Fix array out of bounds with gcc-8.
  * Fix nav_altitude and nav_heading description in README-json.
  * Bump TSV_VERSION for TAH sense fix.
  * Fix reversed sense of Track Angle / Heading bit in surface opstatus messages.
  * Some corrections to JSON doc updates. (upstream /flightaware/dump1090 commit)
  * Bump TSV_VERSION to reflect extensive comm-b changes. (upstream /flightaware/dump1090 commit)
  * Improved comm-b decoding and testing. (several upstream /flightaware/dump1090 commits)
  * Show configurable PageName also in right hand pane info block.
  * Use RTLSDR as default device type.
  * Add configuration hint for clean installation.
  * Add support and build option for bias tee.
  * Keep backward compatible with pre-2.x bladeRF versions.
  * Fix an error in the bit range used to decode CF in DF18 messages.
  * Update README-json to include and explain new fields.
  * Increase maximum TSV packet size
  * Fix possible missing \n termination of TSV messages
  * Fix column index to hide distance when site is not shown.
  * Fix getting LAT/LON from piaware .env file.


=== debian/control ===
Source: readsb
Section: net
Priority: optional
Maintainer: Michael Wolf <michael@mictronics.de>
Build-Depends: debhelper(>=9), libusb-1.0-0-dev, pkg-config, dh-systemd, libncurses5-dev
Build-Depends-Indep: librtlsdr0, librtlsdr-dev, libbladerf2(>=2018.12-rc2), libbladerf-dev, libbladerf-udev
Standards-Version: 4.4.0.1
Homepage: https://github.com/mictronics/readsb
Vcs-Git: https://github.com/mictronics/readsb.git

Package: readsb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lighttpd
Description: ADS-B Ground Station System for various receiver hardware
 Networked Aviation Mode-S/ADS-B/TIS decoder/translator with support for RTL-SDR
 software defined radio USB devices, bladeRF, PlutoSDR, Modes-Beast
 and GNS5894 devices.
 .
 This is a detached fork of dump1090-fa.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

ifeq ($(DEB_HOST_ARCH),armhf)
  # Assume a Pi-like target, where using an 8-bit table is a fairly big win over the float path
  CPPFLAGS += -DSC16Q11_TABLE_BITS=8
endif

CONFIG_SWITCH =

ifneq ($(filter rtlsdr,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCH += 'RTLSDR=yes'
endif

ifneq ($(filter bladerf,$(DEB_BUILD_PROFILES)),)
        CONFIG_SWITCH += 'BLADERF=yes'
endif

ifneq ($(filter plutosdr,$(DEB_BUILD_PROFILES)),)
        CONFIG_SWITCH += 'PLUTOSDR=yes'
endif

ifneq ($(filter biastee,$(DEB_BUILD_PROFILES)),)
        CONFIG_SWITCH += 'HAVE_BIASTEE=yes'
endif

override_dh_auto_build:
	make -j4 $(CONFIG_SWITCH) READSB_VERSION='v3.9.0'

override_dh_install:
	dh_install
	install -d debian/readsb/usr/bin
	cp -a readsb debian/readsb/usr/bin/readsb
	cp -a viewadsb debian/readsb/usr/bin/viewadsb

override_dh_installinit:
	dh_installinit --noscripts

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --with=systemd
